package controller;

import javax.servlet.http.HttpServletRequest;

import model.EntryDAO;
import model.Model;

import org.mybeans.dao.DAOException;

import databean.User;

import controller.Action;
import formbean.EntryForm;
import formbean.LoginForm;

public class AddEntryAction extends Action {
	private EntryDAO entryDAO;

    public AddEntryAction(Model model) {
		entryDAO = model.getEntryDAO();
	}

    public String getName() { return "add-entry"; }

    public String perform(HttpServletRequest request) {
        try {
			int numEntries = entryDAO.getCount();
			request.setAttribute("numEntries",numEntries);

			// Must be logged in for this one
	        User user = (User) request.getSession(true).getAttribute("user");
			if (user == null) {
				LoginForm form = new LoginForm();
				form.setRedirect("/add-entry.do");
		        request.setAttribute("form",form);
				return "login.jsp";
			}

			EntryForm form = new EntryForm();
			form.setId("0");
			request.setAttribute("form",form);
			return "edit-form.jsp";
        } catch (DAOException e) {
        	e.printStackTrace();
        	request.setAttribute("dbError",e.getMessage());
        	return "db-error.jsp";
		}
    }
}
