package controller;

import javax.servlet.http.HttpServletRequest;

import model.Model;

import org.mybeans.dao.DAOException;

import controller.Action;

public class LogoutAction extends Action {
	
	private Model model;

	public LogoutAction(Model model) {
		this.model = model;
	}

	public String getName() { return "logout"; }

	public String perform(HttpServletRequest request) {
        request.getSession(true).setAttribute("user",null);

    	if (!request.getRemoteAddr().startsWith(model.getLocalNetPrefix())) {
    		return "login.jsp";
    	}

        try {
			int numEntries = model.getEntryDAO().getCount();
			request.setAttribute("numEntries",numEntries);
			return "search.jsp";
        } catch (DAOException e) {
        	e.printStackTrace();
        	request.setAttribute("dbError",e.getMessage());
        	return "db-error.jsp";
		}
    }
}
