package formbean;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import org.mybeans.nonmodifiable.NMSQLDate;

import formbean.IdForm;

public class EntryForm extends IdForm {
    private String additional     = "";
    private String address        = "";
    private String birthday       = "";
    private String cellPhone      = "";
    private String city           = "";
    private String country        = "";
    private String digest         = "";
    private String email          = "";
    private String fax            = "";
    private String firstNames     = "";
    private String homePhone      = "";
    private String lastName       = "";
    private String receivedCards  = "";
    private String sentCards      = "";
    private String spouseBirthday = "";
    private String spouseCell     = "";
    private String spouseEmail    = "";
    private String spouseFirst    = "";
    private String spouseLast     = "";
    private String spouseWork     = "";
    private String state          = "";
    private String workPhone      = "";
    private String zip            = "";
    
    private NMSQLDate birthdayDate       = null;
    private NMSQLDate spouseBirthdayDate = null;
 
    public String getAdditional()        { return additional;     }
    public String getAddress()           { return address;        }
    public String getBirthday()          { return birthday;       }
    public String getCellPhone()         { return cellPhone;      }
    public String getCity()              { return city;           }
    public String getCountry()           { return country;        }
    public String getDigest()            { return digest;         }
    public String getEmail()             { return email;          }
    public String getFax()               { return fax;            }
    public String getFirstNames()        { return firstNames;     }
    public String getHomePhone()         { return homePhone;      }
    public String getLastName()          { return lastName;       }
    public String getReceivedCards()     { return receivedCards;  }
    public String getSentCards()         { return sentCards;      }
    public String getSpouseBirthday()    { return spouseBirthday; }
    public String getSpouseCell()        { return spouseCell;     }
    public String getSpouseEmail()       { return spouseEmail;    }
    public String getSpouseFirst()       { return spouseFirst;    }
    public String getSpouseLast()        { return spouseLast;     }
    public String getSpouseWork()        { return spouseWork;     }
    public String getState()             { return state;          }
    public String getWorkPhone()         { return workPhone;      }
    public String getZip()               { return zip;            }
    
    public NMSQLDate getBirthdayAsDate()       { return birthdayDate;       }
    public NMSQLDate getSpouseBirthdayAsDate() { return spouseBirthdayDate; }

    public void setAdditional(String s)     { additional     = s.trim(); }
    public void setAddress(String s)        { address        = s.trim(); }
    public void setBirthday(String s)       { birthday       = s.trim(); }
    public void setCellPhone(String s)      { cellPhone      = s.trim(); }
    public void setCity(String s)           { city           = s.trim(); }
    public void setCountry(String s)        { country        = s.trim(); }
    public void setDigest(String s)         { digest         = s.trim(); }
    public void setEmail(String s)          { email          = s.trim(); }
    public void setFax(String s)            { fax            = s.trim(); }
    public void setFirstNames(String s)     { firstNames     = s.trim(); }
    public void setHomePhone(String s)      { homePhone      = s.trim(); }
    public void setLastName(String s)       { lastName       = s.trim(); }
    public void setReceivedCards(String s)  { receivedCards  = s.trim(); }
    public void setSentCards(String s)      { sentCards      = s.trim(); }
    public void setSpouseBirthday(String s) { spouseBirthday = s.trim(); }
    public void setSpouseCell(String s)     { spouseCell     = s.trim(); }
    public void setSpouseEmail(String s)    { spouseEmail    = s.trim(); }
    public void setSpouseFirst(String s)    { spouseFirst    = s.trim(); }
    public void setSpouseLast(String s)     { spouseLast     = s.trim(); }
    public void setSpouseWork(String s)     { spouseWork     = s.trim(); }
    public void setState(String s)          { state          = s.trim(); }
    public void setWorkPhone(String s)      { workPhone      = s.trim(); }
    public void setZip(String s)            { zip            = s.trim(); }

	public List<String> getValidationErrors() {
		List<String> errors = super.getValidationErrors();
		
		if (lastName.length() == 0) {
			errors.add("Last Name field is required");
		}
		
		if (firstNames.length() == 0) {
			errors.add("First Names field is required");
		}
		
		if (getIdNum() > 0 && digest.length() == 0) {
			errors.add("Digest is missing");
		}
		
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yy");
		
		try {
			if (birthday.length() > 0) {
				Date d = sdf.parse(birthday);
				birthdayDate = new NMSQLDate(d.getTime());
			}
		} catch (ParseException e) {
			errors.add("Birthday has invalid format (use mm/dd/yyyy)");
		}
		
		try {
			if (spouseBirthday.length() > 0) {
				Date d = sdf.parse(spouseBirthday);
				spouseBirthdayDate = new NMSQLDate(d.getTime());
			}
		} catch (ParseException e) {
			errors.add("Spouse Birthday has invalid format (use mm/dd/yyyy)");
		}
		
		return errors;
	}
	
	public boolean isPresent() {
		// Just use present of id as per super class to detect presence of the form
	    return super.isPresent();
	}
}
