package formbean;

import java.util.ArrayList;
import java.util.List;

public class IdForm {
	private String id;

	public String getId() { return id;    }
	
	public int getIdNum() {
		// call getValidationErrors() first to get error messages
		// if errors, this method just returns -1

		if (id == null) return -1;
		
		try {
			return Integer.parseInt(id);
		} catch (NumberFormatException e) {
			return -1;
		}
	}
	public void setId(String id) { this.id = id; }

	public List<String> getValidationErrors() {
		List<String> errors = new ArrayList<String>();
		
		if (id == null || id.length() == 0) {
			errors.add("Id is required");
			return errors;
		}

		try {
			Integer.parseInt(id);
		} catch (NumberFormatException e) {
			errors.add("Id is not an integer");
		}
		
		return errors;
	}
	
	public boolean isPresent() {
		if (id != null) return true;
		return false;
	}
}
