package formbean;

import java.util.ArrayList;
import java.util.List;

public class SearchForm {
	private String last;
	private String first;
	
	public String getLast()  { return last;  }
	public String getFirst() { return first; }
	
	public void setLast(String s)  { last  = s.trim(); }
	public void setFirst(String s) { first = s.trim(); }

	public List<String> getValidationErrors() {
		List<String> errors = new ArrayList<String>();
		
		if (last == null && first == null) {
			errors.add("Must specify start of last name or start of first name");
			return errors;
		}
		
		if (last.length() == 0 && first.length() == 0) {
			errors.add("Must specify part of last name or part of first name");
			return errors;
		}
		
		// Later processing wants empty strings and no null strings, so clean them up.
		if (last == null) last = "";
		if (first == null) first = "";
		
		return errors;
	}
	
	public boolean isPresent() {
		if (last != null) return true;
		if (first != null) return true;
		return false;
	}
}
