package model;

import javax.servlet.http.HttpServletRequest;

import org.mybeans.dao.DAOException;

import model.LogDAO_CSV;
import model.LogDAO_SQL;

public abstract class LogDAO {
	public static LogDAO getSQLInstance(String jdbcDriverName, String jdbcURL, String jdbcUser, String jdbcPassword) throws DAOException {
		return new LogDAO_SQL(jdbcDriverName,jdbcURL, jdbcUser, jdbcPassword);
	}
	
	public static LogDAO getCSVInstance(String fileName) throws DAOException {
		return new LogDAO_CSV(fileName);
	}
	
    public abstract void write(HttpServletRequest request, String text) throws DAOException;
}